#if !defined(SMEM_HPP)
#define SMEM_HPP


#include <cstddef>
#include "mixmodel.hpp"
#include "data.hpp"

void   Merge(const MixtureModel& MM, const Data& D, Matrix& JMerge);
void   Split(const MixtureModel& MM, const Data& D, Matrix& JSplit);
//double KernelDensity(const Data &D, int kernel_type);
void   SortingCandidate(Matrix& JMerge, Matrix& JSplit, Matrix &Candidates);
void   PartialEM(const MixtureModel& MM, const Data& D, MixtureModel& NewMM,
			   int merge1, int merge2, int split, bool DiagonalOnly);
void   InitialParameters(const MixtureModel& MM, MixtureModel& NewMM, 
					  int merge1, int merge2, int split);
double QFunction(const MixtureModel& MM, const Data& D);
//for EM iterations
double SplitMergeEM(MixtureModel& MM, const Data& D,const Matrix& MinimumVariances, 
					int SMEMIterations, int EMIterations, int candidates, bool Verbose);
//for EM threshold
double SplitMergeEM(MixtureModel& MM, const Data& D,const Matrix& MinimumVariances, 
					int SMEMIterations,double EMthreshold, int candidates, bool Verbose);

// for testing use
void test(Matrix mean, Matrix cov);

#endif


